//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
// Copyright (c) Lawrence Livermore National Security, LLC and other Ascent
// Project developers. See top-level LICENSE AND COPYRIGHT files for dates and
// other details. No copyright assignment is required to contribute to Ascent.
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//


//-----------------------------------------------------------------------------
///
/// file: flow_timer.cpp
///
//-----------------------------------------------------------------------------

#include "flow_timer.hpp"


using namespace std::chrono;

//-----------------------------------------------------------------------------
// -- begin flow:: --
//-----------------------------------------------------------------------------
namespace flow
{


//-----------------------------------------------------------------------------
Timer::Timer()
{
    reset();
}

//-----------------------------------------------------------------------------
Timer::~Timer()
{

}

//-----------------------------------------------------------------------------
void
Timer::reset()
{
    m_start = high_resolution_clock::now();
}

//-----------------------------------------------------------------------------
float
Timer::elapsed() const
{
    return duration_cast<duration<float>>(high_resolution_clock::now() - m_start).count();
}



//-----------------------------------------------------------------------------
};
//-----------------------------------------------------------------------------
// -- end flow:: --
//-----------------------------------------------------------------------------



